compiz crashed with SIGSEGV in RegexExp::evaluate()

Bug #706918 reported by Vsevolod Velichko on 2011-01-24
126
This bug affects 24 people
Affects Status Importance Assigned to Milestone
Compiz
Undecided
Unassigned
Arch Linux
Invalid
Undecided
Unassigned
Fedora
Invalid
Undecided
Unassigned
compiz (Ubuntu)
Medium
Unassigned

Bug Description

Binary package hint: compiz

Compiz crashes when ubuntu starts and then I press Alt+tab. As I can see, the source of the problem is Regex matching module. When I disable it (and the Animations module, which depends on Regex), the problem seems to disappear.

ProblemType: Crash
DistroRelease: Ubuntu 11.04
Package: compiz-core 1:0.9.2.1+glibmainloop4-0ubuntu3
ProcVersionSignature: Ubuntu 2.6.35-24.42-generic 2.6.35.8
Uname: Linux 2.6.35-24-generic i686
Architecture: i386
CompisitorRunning: None
CompizPlugins: No value set for `/apps/compiz-1/general/allscreens/options/active_plugins'
CrashCounter: 1
DRM.card0.DisplayPort.1:
 status: disconnected
 enabled: disabled
 dpms: Off
 modes:
 edid-base64:
DRM.card0.LVDS.1:
 status: connected
 enabled: enabled
 dpms: On
 modes: 1280x800
 edid-base64: AP///////wBMo0FNAAAAAAASAQOAGhB4Cof1lFdPjCcnUFQAAAABAQEBAQEBAQEBAQEBAQEBEhsASVAgNjAQMBMABaMQAAAZAAAADwAAAAAAAAAAACOHAmQAAAAA/gBTQU1TVU5HCiAgICAgAAAA/gAxMjFBVDA5LUgwMQogAB4=
DRM.card0.VGA.1:
 status: disconnected
 enabled: disabled
 dpms: Off
 modes:
 edid-base64:
DRM.card1.HDMI_Type_A.1:
 status: disconnected
 enabled: disabled
 dpms: On
 modes:
 edid-base64:
DRM.card1.LVDS.2:
 status: connected
 enabled: enabled
 dpms: On
 modes: 1280x800 1280x720 1152x768 1024x768 800x600 848x480 720x480 640x480
 edid-base64:
DRM.card1.VGA.2:
 status: connected
 enabled: disabled
 dpms: On
 modes:
 edid-base64:
Date: Mon Jan 24 16:34:34 2011
DistUpgraded: Yes, recently upgraded Log time: 2011-01-07 01:23:16.274282
DistroCodename: natty
DistroVariant: ubuntu
DkmsStatus:
 virtualbox-ose, 3.2.12, 2.6.35-24-generic, i686: installed
 virtualbox-ose, 3.2.12, 2.6.37-12-generic, i686: installed
ExecutablePath: /usr/bin/compiz
GraphicsCard: Subsystem: Hewlett-Packard Company Device [103c:3661]
MachineType: Hewlett-Packard HP TouchSmart tm2 Notebook PC
ProcCmdline: compiz --replace
ProcEnviron:
 LANGUAGE=pl_PL:pl:en_GB:en
 PATH=(custom, user)
 LANG=pl_PL.utf8
 LC_MESSAGES=pl_PL.utf8
 SHELL=/bin/bash
ProcKernelCmdLine: BOOT_IMAGE=/boot/vmlinuz-2.6.35-24-generic root=UUID=f4a4d9f8-488c-41fe-aa01-f07e1ac2d460 ro crashkernel=384M-2G:64M,2G-:128M quiet splash video=uvesafb:mode_option=1024x768-24,mtrr=3,scroll=ywrap vt.handoff=7
Renderer: Hardware acceleration
SegvAnalysis:
 Segfault happened at: 0xd9b1fc <_ZN8RegexExp8evaluateEP10CompWindow+108>: mov (%edx),%edx
 PC (0x00d9b1fc) ok
 source "(%edx)" (0x00000014) not located in a known VMA region (needed readable region)!
 destination "%edx" ok
SegvReason: reading NULL VMA
Signal: 11
SourcePackage: compiz
StacktraceTop:
 RegexExp::evaluate(CompWindow*) () from /usr/lib/compiz/libregex.so
 ?? ()
 ?? ()
 DecorWindow::update(bool) () from /usr/lib/compiz/libdecor.so
 DecorWindow::DecorWindow(CompWindow*) () from /usr/lib/compiz/libdecor.so
Title: compiz crashed with SIGSEGV in RegexExp::evaluate()
UnitySupportTest:

UserGroups: adm admin audio cdrom dialout dip floppy fuse lpadmin plugdev pulse pulse-access sambashare video
dmi.bios.date: 06/09/2010
dmi.bios.vendor: Insyde
dmi.bios.version: F.09
dmi.board.asset.tag: Base Board Asset Tag
dmi.board.name: 3661
dmi.board.vendor: Hewlett-Packard
dmi.board.version: KBC Version 47.1A
dmi.chassis.asset.tag: CNU0060FTZ
dmi.chassis.type: 10
dmi.chassis.vendor: Hewlett-Packard
dmi.chassis.version: N/A
dmi.modalias: dmi:bvnInsyde:bvrF.09:bd06/09/2010:svnHewlett-Packard:pnHPTouchSmarttm2NotebookPC:pvr049E100000200800000120000:rvnHewlett-Packard:rn3661:rvrKBCVersion47.1A:cvnHewlett-Packard:ct10:cvrN/A:
dmi.product.name: HP TouchSmart tm2 Notebook PC
dmi.product.version: 049E100000200800000120000
dmi.sys.vendor: Hewlett-Packard
version.libdrm2: libdrm2 2.4.22-2ubuntu1
version.libgl1-mesa-glx: libgl1-mesa-glx 7.9+repack-1ubuntu6
version.xserver-xorg: xserver-xorg 1:7.5+6ubuntu8
version.xserver-xorg-video-ati: xserver-xorg-video-ati 1:6.13.2-1ubuntu2
version.xserver-xorg-video-intel: xserver-xorg-video-intel 2:2.13.901-2ubuntu2
version.xserver-xorg-video-nouveau: xserver-xorg-video-nouveau 1:0.0.16+git20100805+b96170a-0ubuntu1

Vsevolod Velichko (torkvemada) wrote :

StacktraceTop:
 RegexExp::evaluate (this=0x8590938, w=0x8688de0)
 ?? ()

tags: added: apport-failed-retrace
tags: removed: need-i386-retrace
visibility: private → public
tags: added: compiz-0.9
Michael Milligan (milli) wrote :
Download full text (8.6 KiB)

Having the same problem, but I cannot find a reproducable set of steps... yet. Compiz segfaults in libregex library:

Versions, from natty:

$ COLUMNS=160 dpkg -l | grep compiz
ii compiz 1:0.9.2.1+glibmainloop4-0ubuntu3 OpenGL window and compositing manager
ii compiz-core 1:0.9.2.1+glibmainloop4-0ubuntu3 OpenGL window and compositing manager
ii compiz-dev 1:0.9.2.1+glibmainloop4-0ubuntu3 OpenGL window and compositing manager - development files
ii compiz-fusion-plugins-extra 0.9.2.1-0ubuntu2 Collection of extra plugins from OpenCompositing for Compiz
ii compiz-fusion-plugins-main 0.9.2.1-0ubuntu7 Compiz Fusion plugins - main collection
ii compiz-gnome 1:0.9.2.1+glibmainloop4-0ubuntu3 OpenGL window and compositing manager - GNOME window decorator
ii compiz-plugins 1:0.9.2.1+glibmainloop4-0ubuntu3 OpenGL window and compositing manager - plugins
ii compizconfig-backend-gconf 0.9.2.1git101213-0ubuntu1 Compiz Fusion configuration system - gconf backend
ii compizconfig-settings-manager 0.9.2.1-0ubuntu1 Compiz configuration settings manager
ii libcompizconfig0 0.9.2.1git101125-0ubuntu4 Settings library for plugins - OpenCompositing Project
ii libcompizconfig0-dev 0.9.2.1git101125-0ubuntu4 Development file for plugin settings - OpenCompositing Project
ii python-compizconfig 0.9.2.1-0ubuntu2 Compizconfig bindings for python

GDB backtrace...

$ gdb --args compiz --replace
GNU gdb (GDB) 7.1-ubuntu
Copyright (C) 2010 Free Software Foundation, Inc.
License GPLv3+: GNU GPL version 3 or later <http://gnu.org/licenses/gpl.html>
This is free software: you are free to change and redistribute it.
There is NO WARRANTY, to the extent permitted by law. Type "show copying"
and "show warranty" for details.
This GDB was configured as "x86_64-linux-gnu".
For bug reporting instructions, please see:
<http://www.gnu.org/software/gdb/bugs/>...
Reading symbols from /usr/bin/compiz...(no debugging symbols found)...done.
(gdb) run
Starting program: /usr/bin/compiz --replace
[Thread debugging using libthread_db enabled]
No value set for `/apps/compiz-1/general/allscreens/options/active_plugins'
[New Thread 0x7ffff1e1a710 (LWP 18056)]
Backend : gconf
Integration : true
Profile : default
Adding plugins
Initializing core options...done
Initializing bailer options...done
Initializing detection options...done
Initializing composite options...done
Initializing opengl options...done
Initializing decor options...done
/usr/bin/compiz (core) - Warn: Value type is not yet set
Initializing resize options...done
Initializing imgjpeg options...done
Initializing place options...done
Initializing snap options...done
Initializing session options...done
Initializing move options...done
Initializing mousepoll options...done
Initializing imgsvg options...done
Initializing gnomecompat options...done
Initializing winrules options...done
Initializing resizeinfo options...done
Ini...

Read more...

Michael Milligan (milli) wrote :

And the only thing that is saving face (with me) right now is this in a terminal window:

$ while [ 1 ] ; do compiz --replace; done

It is crashing and restarting (per the loop) with no discernible pattern.

Patrick (patrick-voegeli) wrote :

same here.. compiz is unusable due to frequent crashing. After crashing, dmesg says:

compiz[10198]: segfault at 28 ip 00007fad70e8b335 sp 00007fffd3721800 error 4 in libregex.so[7fad70e86000+8000]
[14928.074054] compiz[10398]: segfault at 28 ip 00007fa992bd5335 sp 00007fffd7c3ff60 error 4 in libregex.so[7fa992bd0000+8000]
[15088.032024] compiz[10697]: segfault at 28 ip 00007f87dfb6d335 sp 00007fffacf189f0 error 4 in libregex.so[7f87dfb68000+8000]

Clemens (cle1911) wrote :

same here...
it happens sometimes when opening menues (indicators or dropdown-menues in applications), when dragging starters to the launcher or sometimes just clicking, but with no recognizable regularity behind it

Ronnie (ronnie-10) wrote :

This bug keeps on happening. Its been happening since 40 days. That is when i upgraded from maverick to NATTY. It happens on kernels 2.6.36, 2.6.38, the generic ubuntu kernel too. I tested it with 5 different kernels. The following message is found in /var/log/syslog

Apr 30 17:51:37 solidus-workstation kernel: [437609.857278] compiz[19952]: segfault at 10 ip 00007fa564066335 sp 00007fff096e1350 error 4 in libregex.so[7fa564061000+8000]

Long ago b4 the upgrade there was no problems with the 2.6.36 kernel. Therefore im sure its not a kernel problem. Moreover, it used to happen a lot b4 the last 2 compiz updates. Now it happens only twice or 3 times when i log in to the system nd then it takes a long time to happen again. Also if i logout nd log in again, the same story repeats where compiz crashes 2 or 3 times and then takes a very long time to crash . The crash occurs when new windows open such as when u open banshee or the sound preferences or any gtk window etc...

Ronnie (ronnie-10) wrote :

Also, it happens sometimes when opening menus (indicators or dropdown-menus in applications) and when dragging folders on the desktop or in nautilus.

Alexander K (kwargs) wrote :

similar problem:

May 5 15:08:54 pioneer kernel: [18612.444848] compiz[11375]: segfault at 14 ip 0082436c sp bfed6b30 error 4 in libregex.so[820000+7000]
May 5 15:10:32 pioneer kernel: [18711.107390] compiz[11434]: segfault at 14 ip 007d136c sp bfb6a5f0 error 4 in libregex.so[7cd000+7000]

~$ apt-cache policy compiz compiz-plugins
compiz:
  Installed: 1:0.9.4+bzr20110415-0ubuntu2
  Candidate: 1:0.9.4+bzr20110415-0ubuntu2
  Version table:
 *** 1:0.9.4+bzr20110415-0ubuntu2 0
        500 http://archive.ubuntu.com/ubuntu/ natty/main i386 Packages
        100 /var/lib/dpkg/status
compiz-plugins:
  Installed: 1:0.9.4+bzr20110415-0ubuntu2
  Candidate: 1:0.9.4+bzr20110415-0ubuntu2
  Version table:
 *** 1:0.9.4+bzr20110415-0ubuntu2 0
        500 http://archive.ubuntu.com/ubuntu/ natty/main i386 Packages
        100 /var/lib/dpkg/status

sab (sab-dreamflow) wrote :

I seem to be having this a lot more when I'm running conky. I'm not sure if that's related.

The same issue ocurrs on Fedora 15, and ArchLinux with compiz 0.9.4, so this is an upstream compiz bug.
On Arch, the issue ocurrs whenever a tooltip is displayed, or a menu is opened. Disabling regex matching prevents these crashes.

Pedro Villavicencio (pedro) wrote :

Thanks for your bug report. Please try to obtain a backtrace http://wiki.ubuntu.com/DebuggingProgramCrash and attach the file to the bug report. This will greatly help us in tracking down your problem.

Changed in compiz (Ubuntu):
importance: Undecided → Medium
status: New → Incomplete
Vsevolod Velichko (torkvemada) wrote :

Unfortunately I can't use compiz at all at the moment (because of #781804), so, please, anyone who confirmed the bug, produce the appropriate stacktrace.

sab (sab-dreamflow) wrote :

Unfortunately, I can't either. Since I've reverted to Lucid because of (amongst other things) this.

Charlie Kravetz (charlie-tca) wrote :

We are closing this bug report because it lacks the information we need to investigate the problem, as described in the previous comments. Please reopen it if you can give us the missing information, and don't hesitate to submit bug reports in the future. To reopen the bug report you can click on the current status, under the Status column, and change the Status back to "New". Thanks again!

Changed in archlinux:
status: Incomplete → Invalid
Changed in compiz (Ubuntu):
status: Incomplete → Invalid

I'm including an attachment generated with compiz 0.9.4, though not on Ubuntu (my GF's laptop is the one with ubuntu, and she's on a long trip so I won't have access to it for some time).

I hope this helps, I've generated it following the instructions at https://wiki.ubuntu.com/Backtrace.

In any case, just get back to me.
The EXACT same compiz config does not crash on a different PC with the same software configuration (os, compiz version, etc). That one has intel video, and this one nvidia, that's the only difference I can think of.

Cheers!

Changed in compiz (Ubuntu):
status: Invalid → New
Changed in archlinux:
status: Invalid → New

I forgot to say; the crashes are not only when alt-tabbing, but also when opening menus, if I open File, then Edit, and go back and fourth a couple of times, I get the same crash. Disabling regex matching fixes BOTH crashes, so I've always considered them the same one.

Charlie Kravetz (charlie-tca) wrote :

Marking both arch and fedora tasks as invalid until such time as valid bug reports for those are provided. It is highly unlikely that ubuntu developers are going to work those distributions.

Changed in fedora:
status: New → Invalid
Changed in archlinux:
status: New → Invalid
Carey Underwood (cwillu) on 2011-05-29
Changed in compiz (Ubuntu):
status: New → Confirmed
Carey Underwood (cwillu) wrote :

(gdb) bt
#0 RegexExp::evaluate (this=0xd30d10, w=<value optimized out>)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/plugins/regex/src/regex.cpp:137
#1 0x00000000004480bf in matchEvalOps (list=..., w=0x10f2730)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/src/match.cpp:481
#2 0x000000000044807b in matchEvalOps (list=..., w=0x10f2730)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/src/match.cpp:476
#3 0x00007fd17728b939 in DecorWindow::update (this=0x11573b0,
    allowDecoration=true)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/plugins/decor/src/decor.cpp:877
#4 0x00007fd17728e854 in DecorWindow::DecorWindow (this=0x11573b0,
    w=0x10f2730)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/plugins/decor/src/decor.cpp:2139
#5 0x00007fd177291eb9 in VTableForScreenAndWindow<DecorScreen, DecorWindow>::initWindow (this=<value optimized out>, w=0x10f2730)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/include/core/plugin.h:257
#6 0x0000000000450e95 in CompPlugin::windowInitPlugins (w=0x10f2730)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/src/plugin.cpp:396
#7 0x0000000000442007 in CompWindow::CompWindow (this=0x10f2730,
    aboveId=<value optimized out>, wa=..., priv=0x1157030)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/src/window.cpp:5305
#8 0x0000000000442470 in CoreWindow::manage (this=0x114f2d0,
    aboveId=81792395, wa=...)
    at /home/cwillu/work/compiz/compiz-0.9.4+bzr20110415/src/window.cpp:5324
#9 0x000000000044f473 in CompScreen::handleEvent (this=0x9f09f0,
    event=0x7fff92a34f40)
---Type <return> to continue, or q <return> to quit---q

Dean Sadites (dsadites) wrote :

I first noticed this problem when I started running Conky. However, it had nothing to do with Conky itself, but rather with the rule I put in ccsm (CompizConfig Settings Manager) to disable shadows on the Conky window [i.e. Window Decorations -> Shadow Windows = (any) & !(class=Conky)]. This causes Compiz to segfault in libregex.so, probably because it's using regex to try to match the window class/title. To prove this, I stopped running Conky but left the rule in place and, sure enough, Compiz continues to crash at random times. Removing the rule fixed the intermittent crashes in my case.

Mark Furneaux (markfurneaux) wrote :

I can confirm that the settings change in #22 does stop the crashes.

I had this bug on ArchLinux and Fedora with compiz 0.9.4 on the same PC. Upgrading to compiz 0.9.5 (development release) fixed this issue, can someone verify this is also the case on ubuntu?

Removing window matching rules in Window Decorations -> Shadow Windows resolved the crashes for me, too (now I'm using devilspie to unshadow windows).

Window matching rules in other plugins (like Animations) work fine, so the Window Decorations plugin seems to be the source of trouble.

I'm running Ubuntu 11.04.

tom (tasker) wrote :

#22 is the perfect answer. Same effect here!

When I remove window matching rules in Window Decorations -> Shadow Windows my crashes are resolved =

i.e. Window Decorations -> Shadow Windows = (any) & !(class=Conky).

Tristan (astotris) wrote :

I found a patch for the bug here: https://bugzilla.redhat.com/show_bug.cgi?id=710809

I tested it and it solves this for me!

Also, I have the patch applied to the standard compiz package and available via ppa:
https://launchpad.net/~astotris/+archive/simple-compiz-patch

Attached here:
patch
i386 libregex.so
amd64 libregex.so

Tristan (astotris) wrote :

see attached i386 libregex.so

Tristan (astotris) wrote :

see attached amd64 libregex.so

tags: added: patch

We confirm the #22 workaround.
Anyway, the patch solved the problem in 32bits and 64bits.

MC Return (mc-return) on 2013-07-08
Changed in compiz:
milestone: none → 0.9.10.0
MC Return (mc-return) wrote :

ProblemType: Crash
DistroRelease: Ubuntu 11.04
Package: compiz-core 1:0.9.2.1+glibmainloop4-0ubuntu3

Setting to incomplete, please confirm if it still happens...

Changed in compiz:
milestone: 0.9.10.0 → 0.9.11.0
status: New → Incomplete
Stephen M. Webb (bregma) on 2015-01-13
tags: added: plugin-regex
Will Cooke (willcooke) wrote :

As part of the big bug clear up for 16.04 LTS I am marking this bug as Wont Fix.
These types of crasher are better handled by errors.ubutnu.com which can collate similar crash reports to help us identify persitent bugs rather than one-off crashes.
Sorry we are not able to help with this specific issue. If you are still experiencing this crash, please re-open the bug and add the tag "desktop-bugscrub-reopened". See https://wiki.ubuntu.com/BigDesktopBugScrub for more information.

Changed in compiz:
status: Incomplete → Won't Fix
Changed in compiz (Ubuntu):
status: Confirmed → Won't Fix
tags: added: desktop-bugscrub-autoclosed

@willcooke:

 - This *is* a persistent bug.
 - errors.ubutnu.com does not exist
 - this error is not ubuntu-specific. What happens in this case?

Reproduction instructions are quite clearly described on this ticket.

tags: added: desktop-bugscrub-reopened
To post a comment you must log in.
This report contains Public information  Edit
Everyone can see this information.

Other bug subscribers

Remote bug watches

Bug watches keep track of this bug in other bug trackers.